<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="h-full px-6 flex items-center justify-center hover:bg-whitesmoke cursor-pointer" (click)="openPanel()">
  <div class="relative" [ngClass]="{ ' mt-2': indicate, 'mt-1': !indicate }">
    <i class="fa fa-bell" style="font-size: 1rem"></i>
    <ng-container *ngLet="newNotifications$ | async">
      <div *ngIf="indicate" class="animate-ping absolute -top-0.5 -right-1.5 rounded-full bg-yellow size-2"></div>
      <div *ngIf="indicate" class="absolute -top-0.5 -right-1.5 rounded-full bg-yellow size-2"></div>
    </ng-container>
  </div>
  <app-top-panel #panel  [marginRight]="0" [(visible)]="visible" (visibleChange)="closePanel()">
    <ng-template #activeIcon>
      <i class="float-left fa-bell text-primary-500 mt-1" style="font-size: 1rem"></i>
    </ng-template>
    <div class="max-h-[600px] w-[420px] flex flex-col">
      <div class="border-b border-borderGrey pb-3 text-sm font-semibold text-text-300 flex items-center justify-between gap-4 w-full">
        <div>
          Notifications<span *ngIf="(notifications$ | async)?.length as len"> {{ len > 1000 ? ' (1000+)' : ' (' + len + ')' }}</span
          >:
        </div>
        <p-button size="small" [link]="true" label="Mark all seen" severity="secondary" (onClick)="markAllSeen()"></p-button>
      </div>
      <div *ngIf="initializing$ | async; else loaded" class="w-full flex flex-col gap-2">
        <p-skeleton height="64px" width="100%"></p-skeleton>
        <p-skeleton height="64px" width="100%"></p-skeleton>
        <p-skeleton height="64px" width="100%"></p-skeleton>
      </div>
      <ng-template #loaded>
        <div *ngIf="errorInitializing$ | async as error; else result">
          <div class="w-full flex flex-col items-center gap-10 py-10">
            <div class="text-lg font-semibold text-text-300">
              <app-sad-face></app-sad-face>
            </div>
            <div class="flex flex-col gap-4 items-center">
              <p-message severity="warning" [text]="error != null ? 'Failed to load notifications' : undefined"></p-message>
              <p-button label="Try Again" [outlined]="true" size="small" (click)="onTryAgain()"></p-button>
            </div>
          </div>
        </div>
        <ng-template #result>
          <div class="grow overflow-y-auto divide-y divide-borderGrey">
            <ng-container *ngLet="notifications$ | async as notifications">
              <ng-container *ngIf="notifications && notifications.length > 0; else empty">
                <div *ngFor="let notification of notifications$ | async">
                  <app-notification [notification]="notification" (onSelect)="close($event)"></app-notification>
                </div>
              </ng-container>
              <ng-template #empty>
                <div class="w-full flex flex-col items-center gap-4 py-10">
                  <div class="text-lg font-semibold text-text-300">
                    <app-sad-face></app-sad-face>
                  </div>
                  <div class="text-text-300">No notifications</div>
                </div>
              </ng-template>
            </ng-container>
          </div>
        </ng-template>
      </ng-template>
    </div>
  </app-top-panel>
</div>
